unit Unit1;
// **************************************************************************
// *          *
// *  , www.chat.ru/~z_ol
// **************************************************************************
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls, IniFiles;

type
  TMain = class(TForm)
    TreeView1: TTreeView;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Image1: TImage;
    Splitter2: TSplitter;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
  private
    { Private declarations }
  public
   Function LoadSubItems(TN : TTreeNode; Sect : string):boolean;
   Function LoadObjectInfo(Num : integer):boolean;
  end;

var
  Main: TMain;

implementation

{$R *.DFM}

//     -   
procedure TMain.FormCreate(Sender: TObject);
var
 Count,i   : integer;
 INI       : TINIFile;
 Temp      : TTreeNode;
begin
 TreeView1.Items.Clear;
 INI := TINIFile.Create(ExtractFilePath(Application.ExeName)+'data.ini');
 Count := INI.ReadInteger('Main','Count',0);
 for i:=1 to Count do begin
  //   (root) 
  Temp := TreeView1.Items.AddObject(nil, INI.ReadString(INI.ReadString('Main','T'+inttostr(i),'**'),'Name','??'),
           Pointer(INI.ReadInteger(INI.ReadString('Main','T'+inttostr(i),'**'),'Code',0)));
  //   
  LoadSubItems(Temp,INI.ReadString('Main','T'+inttostr(i),'**'));
 end;
end;

//         Num. 
//         
function TMain.LoadObjectInfo(Num: integer): boolean;
var
 Path, TextInfo, ImageInfo : string;
begin
 // Caption := ' '+inttostr(Num); //   
 Path := ExtractFilePath(Application.Exename);
 //       
 TextInfo  := Path+'Data\Text'+inttostr(Num)+'.txt';
 ImageInfo := Path+'Data\Image'+inttostr(Num)+'.bmp';
 Memo1.Lines.Clear;
 //  (   )
 if FileExists(TextInfo) then
  Memo1.Lines.LoadFromFile(TextInfo);
 if FileExists(ImageInfo) then
  Image1.Picture.LoadFromFile(ImageInfo);
 Image1.Visible := FileExists(ImageInfo);
 Memo1.Visible  := FileExists(TextInfo);
end;

//  .      
//    
function TMain.LoadSubItems(TN: TTreeNode; Sect: string): boolean;
var
 Count,i   : integer;
 INI       : TINIFile;
 Temp      : TTreeNode;
begin
 INI := TINIFile.Create(ExtractFilePath(Application.ExeName)+'data.ini');
 Count := INI.ReadInteger(Sect,'SubCount',0);
 for i:=1 to Count do begin
  Temp := TreeView1.Items.AddChildObject(TN, INI.ReadString(INI.ReadString(Sect,'S'+inttostr(i),'**'),'Name','??'),
           Pointer(INI.ReadInteger(INI.ReadString(Sect,'S'+inttostr(i),'**'),'Code',0)));
  //  -      
  LoadSubItems(Temp,INI.ReadString(Sect,'S'+inttostr(i),'**'));
 end;
end;

//   
procedure TMain.TreeView1Change(Sender: TObject; Node: TTreeNode);
begin
 LoadObjectInfo(Integer(Node.Data));
end;

end.
